<?php
/*
    ----------------------------------------------------------------------
 * Karma System 3.3
 * Originally Developed by: FunForum
 * Version 2.0-3.3 Developed by:  The XMB Group
 * Copyright (c) 2001-2006 FunForum
 * Copyright (c) 2008-2012 The XMB Group
 * http://www.xmbforum2.com/

    All copyright information must remain visible and cannot be removed.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the
    Free Software Foundation Inc.
    59 Temple Place Suite 330
    Boston, MA  02111-1307  USA
    ----------------------------------------------------------------------
*/

if (!defined('IN_CODE')) {
    exit("Not allowed to run this file directly.");
}

$header = '';
$memberpage = '';

    if ( $SETTINGS['karma_status'] != "on" ) {
        nav($lang['error']);
        //eval('echo "'.template('header').'";');
        eval('echo "'.template('header').'";');
        eval('echo "'.template('misc_feature_notavailable').'";');
        end_time();
        eval('echo "'.template('footer').'";');
        exit;
    }

    if ( X_GUEST) {
        error($lang['welcomeunregnotify']);
    }
	$member = postedVar('member', '', TRUE, TRUE, TRUE, 'r');
    if ( empty($member) ) {
        error($lang['karma_nomember']);
    }
    $query = $db->query("SELECT * FROM ".X_PREFIX."members WHERE username='$member'");
    $M = $db->fetch_array($query);

    // Check to see if member exists
    if ( empty($M['uid']) ) {
        error($lang['nomember']);
    }
    $member = $M['username'];
    $db_member = $db->escape($M['username']);

    $karma_banuser = '|#|'.str_replace(',', '|#|', str_replace(', ', ',', $SETTINGS['karma_banuser'])).'|#|';
    $karma_allow = '|#|'.str_replace(',', '|#|', str_replace(', ', ',', $SETTINGS['karma_allow'])).'|#|';
    $karma_timegroup = '|#|'.str_replace(',', '|#|', str_replace(', ', ',', $SETTINGS['karma_timegroup'])).'|#|';

    $disallow = (false !== strpos($karma_banuser, '|#|'.$self['username'].'|#|') ? '' : 'no');
    $specialallow = (false !== strpos($karma_allow, '|#|'.$self['status'].'|#|') ? 'yes' : '');
    $derestrict = (false !== strpos($karma_timegroup, '|#|'.$self['status'].'|#|') ? 'yes' : '');

    if (empty($status_enum[$self['username']])) {
        $specialallow = (false !== strpos($karma_allow, '|#|'.$self['username'].'|#|') ? 'yes' : $specialallow);
        $derestrict = (false !== strpos($karma_timegroup, '|#|'.$self['username'].'|#|') ? 'yes' : $derestrict);
    }

    $Fv = explode("|#|", $SETTINGS['karma_timerestrict']);
    if ( empty($derestrict) && ((time() - $self['vtime']) < ($Fv[0] * $Fv[1])) ) {
        if ('off' == $SETTINGS['karma_timepermem']) {
            $disallow = '';
        } else {
            // Did $xmbuser recently praise or bash $member?
            $timelimit = time() - ($Fv[0] * $Fv[1]);
            $result = $db->query("SELECT COUNT(*) FROM ".X_PREFIX."karmalog WHERE dateline >= $timelimit AND fuid = {$self['uid']} AND tuid = {$M['uid']}");
            $result = $db->result($result, 0);
            if ($result > 0) {
                $disallow = '';
            }
        }
    }
    if ($xmbuser == $member) {
        $disallow = '';
    }
    if (!
      (
       X_SADMIN ||
       $SETTINGS['karma_bynum'] == 0 && $SETTINGS['karma_bypost'] == 0 ||
       $SETTINGS['karma_bynum'] > 0 && $self['karma'] >= $SETTINGS['karma_bynum'] ||
       $specialallow == "yes" ||
       $SETTINGS['karma_bypost'] > 0 && $self['postnum'] >= $SETTINGS['karma_bypost']
      )
    ) {
        $disallow = '';
    }

    $mode = 'fail';
    if ($disallow == "no") {
        $doitto = '';
        $doitfrom = '';
        switch($do){
        case 'smite':
            if ($SETTINGS['karma_moneysmite'] > 0 and $M['money'] >= $SETTINGS['karma_moneysmite']) {
                $doitto = "money=money-{$SETTINGS['karma_moneysmite']}, ";
                $doitfrom = "money=money+{$SETTINGS['karma_moneysmite']}, ";
                $self['money'] += $SETTINGS['karma_moneysmite'];
            }
            $db->query("UPDATE ".X_PREFIX."members SET $doitfrom vtime='$onlinetime' WHERE uid={$self['uid']}");
            $db->query("UPDATE ".X_PREFIX."members SET $doitto karma=karma-{$SETTINGS['karma_increment']} WHERE uid={$M['uid']}");
            $self['vtime'] = $onlinetime;
            $omessage = $lang['karma_edit'];
            $mode = 'smite';
            break;
        case 'praise':
            if ($SETTINGS['karma_moneypraise'] > 0 and $self['money'] >= $SETTINGS['karma_moneypraise']) {
                $doitto = "money=money+{$SETTINGS['karma_moneypraise']}, ";
                $doitfrom = "money=money-{$SETTINGS['karma_moneypraise']}, ";
                $self['money'] -= $SETTINGS['karma_moneypraise'];
            }
            $db->query("UPDATE ".X_PREFIX."members SET $doitfrom vtime='$onlinetime' WHERE uid={$self['uid']}");
            $db->query("UPDATE ".X_PREFIX."members SET $doitto karma=karma+{$SETTINGS['karma_increment']} WHERE uid={$M['uid']}");
            $self['vtime'] = $onlinetime;
            $omessage = $lang['karma_edit'];
            $mode = 'praise';
            break;
        default:
            nav($lang['error']);
            $omessage = $lang['karma_noaction'];
            break;
        }
    } else {
        nav($lang['error']);
        $omessage = $lang['karma_noedit'];
    }

    if ($mode != 'fail') {
        $db->query(
            "INSERT INTO ".X_PREFIX."karmalog (`fuid` , `fuser` , `tuid` , `tuser` , `amount` , `mode` , `dateline` ) "
          . "VALUES ('{$self['uid']}', '$xmbuser', '{$M['uid']}', '$db_member', '{$SETTINGS['karma_increment']}', '$mode', '$onlinetime')"
        );
    }

    eval('echo "'.template('header').'";');
    echo '<table cellspacing="0" cellpadding="0" border="0" width="'.$THEME['tablewidth'].'" align="center">
    <tr><td bgcolor="'.$THEME['bordercolor'].'">
    <table border="0" cellspacing="'.$THEME['borderwidth'].'" cellpadding="'.$THEME['tablespace'].'" width="100%">
      <tr>
        <td bgcolor="'.$THEME['altbg1'].'" class="mediumtxt" align="center">'.str_replace("*karma*", $SETTINGS['karma_title'], $omessage).'</td>
      </tr>
    </table>
    </td></tr></table>';
    $tid = getInt('tid');
    $pid = getInt('pid');
    redirect(($fr == "view" ? "viewthread.php?goto=search&tid=$tid&pid=$pid" : ($fr == "pro" ? 'member.php?action=viewpro&member='.recodeOut($member) : ($fr == "mem" ? "misc.php?action=list" : "index.php"))), 2, '');
?>
